/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/

 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.

 * The Original Code is Rhino code, released
 * May 6, 1999.

 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1997-1999 Netscape Communications Corporation. All
 * Rights Reserved.

 * Contributor(s): 

 * Alternatively, the contents of this file may be used under the
 * terms of the GNU Public License (the "GPL"), in which case the
 * provisions of the GPL are applicable instead of those above.
 * If you wish to allow use of your version of this file only
 * under the terms of the GPL and not to allow others to use your
 * version of this file under the NPL, indicate your decision by
 * deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL.  If you do not delete
 * the provisions above, a recipient may use your version of this
 * file under either the NPL or the GPL.
 */
#if defined( SUNOS5 ) || linux

/* Header file */
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/uio.h>
#include <sys/fcntl.h>
#include "js-filereader.h"

/* Procedures */
int
JSFileReader::read(jsString_t cbuf, int off, int len) 
{
    int n = ::read( fd, cbuf + off, len );

    return ( n <= 0 ? -1 : n );
}
JSFileReader::JSFileReader(jsString_t filename )
{
    fd = ::open( filename, O_RDONLY, 0 );
    if ( fd < 0 ) {
	// ASSERT
	printf( "JSFileReader::JSFileReader: can't open %s\n",
			filename ); 
    }
    unsigned char text[ 3 ];
    int n = ::read( fd, text, sizeof ( text ) );

    if ( n < 0 ) {
	// ASSERT
	printf( "JSFileReader::JSFileReader: can't read %s\n",
			filename ); 
    }
    if ( n == sizeof ( text ) ) {
    	// Check BOM
    	if( *text == 0xef && *(text+1) == 0xbb && *(text+2) == 0xbf ){
	    return;
	}
    }
    ::lseek( fd, 0L, SEEK_SET );
}
JSFileReader::~JSFileReader()
{
    if ( fd >= 0 ) {
	::close( fd );
    }
}
#endif /* defined( SUNOS5 ) || linux */
